(* ------------------------------------------------------------------------- *)

(* [translate entry graph] turns an [LTL] control flow graph into
   a [LIN] sequence of instructions. *)

let translate entry graph =

  (* Traverse the control flow graph. *)

  let rec visit l = failwith "Pas implment !"

  and visit_fresh l = failwith "Pas implment !"

  in
  visit entry;

  []

(* ------------------------------------------------------------------------- *)

(* Extend the translation to procedures and programs. *)

let translate_procedure proc =
  {
    LIN.formals = proc.LTL.formals;
    LIN.locals = proc.LTL.locals;
    LIN.code = translate proc.LTL.entry proc.LTL.graph
  }

let translate_program (p : LTL.program) : LIN.program =
  {
    LIN.globals = p.LTL.globals;
    LIN.defs = StringMap.map translate_procedure p.LTL.defs
  }

